/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CCalcCentDedDgrRessyasenOfPoint.cpp
// $Id: CCalcCentDedDgrRessyasenOfPoint.cpp 94 2012-09-29 12:11:37Z okm $
// ****************************************************************
*/
/** @file */
#include "stdafx.h"

#include "DcdCd\Pos\CLineFunc.h"
#include "LogMsg\LogMsg.h"

#include "CCalcCentDedDgrRessyasenOfPoint.h"

namespace ViewDiagram{

CCalcCentDedDgrRessyasenOfPoint::CCalcCentDedDgrRessyasenOfPoint(
		CDcdDiagram* pCDcdDiagram , 
		IfDcdTarget* pIfDcdTarget ,
		const CdDcdPosXy& aCdDcdPosXy , int iMarginPixels ,
		bool bDisplayRessyasenKudari , bool bDisplayRessyasenNobori ) : 
	super( pCDcdDiagram->getCentDedDgrDia() , 
		pCDcdDiagram->DgrFromDcd( pIfDcdTarget , pIfDcdTarget->getZone() ) , 
		bDisplayRessyasenKudari , 
		bDisplayRessyasenNobori ) , 
	m_pCDcdDiagram( pCDcdDiagram ) ,
	m_pIfDcdTarget( pIfDcdTarget ) ,
	m_CdDcdPosXy( aCdDcdPosXy ) ,
	m_iMerginPixels( iMarginPixels ) ,
	m_eRessyahoukou( Ressyahoukou_Kudari ) ,
	m_iRessyaIdx( -1 ) ,
	m_iRessyasenIdx( -1 )
{
};

void CCalcCentDedDgrRessyasenOfPoint::onCentDedDgrRessyasen( 
			ERessyahoukou eRessyahoukou ,
			int iRessyaIdx ,
			const CentDedDgrRessya* pCentDedDgrRessya ,
			int iRessyasenIdx ,
			const CentDedDgrRessyasen* pCentDedDgrRessyasen ) 
{
	//	ԐĂꍇ́A
	//	͍̌̏s킸Ƀ^[
	if ( m_iRessyaIdx != -1 )
	{
		return ;
	}	
	// --------------------------------
	CdDcdPosXy	posDgrPosRessyasenKiten = 
		getCentDedDgrDia()->calcDgrPosRessyasenKiten( 
			pCentDedDgrRessya , 
			pCentDedDgrRessyasen ) ;
	CdDcdPosXy	posDgrPosRessyasenSyuuten = 
		getCentDedDgrDia()->calcDgrPosRessyasenSyuuten( 
			pCentDedDgrRessya , 
			pCentDedDgrRessyasen ) ;
	//posDgrPosRessyasenKiten,posDgrPosRessyasenSyuuten = 
	//	̗Ԑ̋N_ƏI_̍WA
	//	DgrWnŕ\܂B

	CLineFunc aCLineFunc( 
		m_pCDcdDiagram->DgrToDcd( m_pIfDcdTarget , 
			posDgrPosRessyasenKiten )  , 
		m_pCDcdDiagram->DgrToDcd( m_pIfDcdTarget , 
			posDgrPosRessyasenSyuuten ) ) ;
	//aCLineFunc = 
	//	̗Ԑ̋N_I_܂łԒA
	//	DcDraw Wnŕ\܂B

	LogMsg(_T("CCalcCentDedDgrRessyasenOfPoint::onCentDedDgrRessyasen(")
		_T("eRessyahoukou=%d ,iRessyaIdx=%d ,,iRessyasenIdx =%d,)")  ,
		eRessyahoukou ,
		iRessyaIdx ,
		iRessyasenIdx  ) ; 
	LogMsg(_T("\taCLineFunc.Pos1=%d,%d , Pos2=%d,%d   m_CdDcdPosXy=%d,%d") ,
		aCLineFunc.getPos1().getX() , 
		aCLineFunc.getPos1().getY() , 
		aCLineFunc.getPos2().getX() , 
		aCLineFunc.getPos2().getY() ,
		m_CdDcdPosXy.getX() , m_CdDcdPosXy.getY() ) ;

	// --------------------------------
	//	uwΏۓ_xAԐ̎n_EI_܂钷`
	//	͈͓ɂ邩v𔻒
	// --------------------------------
	{
		CdDcdZone	zoneDcdXBoundRessyasen ;
		{
			zoneDcdXBoundRessyasen.setBeginEndPos( 
				aCLineFunc.getPos1().getX() ,
				aCLineFunc.getPos2().getX() ) ;
			//	TCY0̏ꍇ́A1ɍœK܂B
			//	n_ƏI_XWꍇ()
			//	Y܂B
			if ( zoneDcdXBoundRessyasen.getSize() == 0 )
			{
				zoneDcdXBoundRessyasen.setSize( 1 ) ;
			}
		}
		//zoneDcdXBoundRessyasen = 
		//	Ԑ̋N_I_܂łXẄ̗łB
		//	DcdWnŕ\܂B
		//	TCY0̏ꍇ́A1ɍœK܂B

		CdDcdZone	zoneDcdYBoundRessyasen ;
		{
			zoneDcdYBoundRessyasen.setBeginEndPos( 
				aCLineFunc.getPos1().getY() ,
				aCLineFunc.getPos2().getY() ) ;

			//	TCY0̏ꍇ́A1ɍœK܂B
			//	n_ƏI_YWꍇ()ꍇ
			//	Y܂B
			if ( zoneDcdYBoundRessyasen.getSize() == 0 )
			{
				zoneDcdYBoundRessyasen.setSize( 1 ) ;
			}
		}
		//zoneDcdYBoundRessyasen = 
		//	Ԑ̋N_I_܂łYẄ̗łB
		//	DcdWnŕ\܂B
		//	TCY0̏ꍇ́A1ɍœK܂B

		CdDcdZoneXy	zonexyDcdBoundRessyasen( 
			zoneDcdXBoundRessyasen ,
			zoneDcdYBoundRessyasen ) ;
		//zonexyDcdBoundRessyasen = 
		//	Ԑ̋N_I_܂ł͂ޒ`̗̈łB
		//	X,YƂATCY0̏ꍇ́A1ɍœK܂B
		//RF
		//	Ԑ̏ꍇAʂɌvZƁA
		//	zonexyDcdBoundRessyasen XSize ́A0ɂȂ܂B
		//	AzonexyDcdBoundRessyasen X ܂ Y  Size 
		//	0 ƁA zonexyDcdBoundRessyasen.IsInner() ̌ʂ͏
		//	false ɂȂA͈͓̔肪ł܂B
		//	邽߂ɁAX,YSizéA0 ̏ꍇ 1ɍœK܂B

		if ( !zonexyDcdBoundRessyasen.IsInner( m_CdDcdPosXy ) )
		{
			//	wΏۓ_xAԐ̎n_EI_܂钷`
			//	͈͓ɂ܂B
			return ;
		}
	}
	// --------------------------------
	//	Ώۓ_AԐ̐ɂ邱Ƃ𔻒
	// --------------------------------
	if ( abs( aCLineFunc.getPos1().getX() - aCLineFunc.getPos2().getX() ) >
		abs( aCLineFunc.getPos1().getY() - aCLineFunc.getPos2().getY() ) )
	{
		//	X̕Ԑ
		int iY = aCLineFunc.calcYofX( m_CdDcdPosXy.getX() ) ;
		if ( abs( iY - m_CdDcdPosXy.getY() ) <= m_iMerginPixels )
		{
			LogMsg(_T("\tfind iY=%d") , iY ) ;
			m_eRessyahoukou = eRessyahoukou ;
			m_iRessyaIdx = iRessyaIdx ;
			m_iRessyasenIdx = iRessyasenIdx ;
		}
	}
	else
	{
		//	Y̕Ԑ
		int iX = aCLineFunc.calcXofY( m_CdDcdPosXy.getY() ) ;
		if ( abs( iX - m_CdDcdPosXy.getX() ) <= m_iMerginPixels )
		{
			LogMsg(_T("\tfind iX=%d") , iX ) ;
			m_eRessyahoukou = eRessyahoukou ;
			m_iRessyaIdx = iRessyaIdx ;
			m_iRessyasenIdx = iRessyasenIdx ;
		}
	} 
	//m_eRessyahoukou,m_iRessyaIdx,m_iRessyasenIdx = 
	//	Ώۓ_ʂԐꍇ́A
	//	̗ԐƂȂ܂B
};
} //namespace ViewDiagram
