/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CdDedJikan.cpp
// ****************************************************************
*/
#include "stdafx.h"

#include <deque>
using namespace std ;

#include "CdDedJikan.h"
#include "str/stringSplit.h"
#include "str/strprintf.h"
#include <tchar.h>


#ifndef _CONSOLE
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#endif

namespace entDed{
	using namespace OuLib::Str;
// ****************************************************************
//	CdDedJikan::CConv
// ****************************************************************
CdDedJikan::CConv::CConv() 
	: m_bNoSecond( false )
	, m_bPlusDisplay( false ) 
	, m_bPlusToSpace( false ) 
{
};

CdDedJikan::CConv::CConv( 
			bool bNoSecond ,
			bool bPlusDisplay ,
			bool bPlusToSpace  ) 
	: m_bNoSecond( bNoSecond )
	, m_bPlusDisplay( bPlusDisplay ) 
	, m_bPlusToSpace( bPlusToSpace ) 
{
}

tstring CdDedJikan::CConv::encode( const CdDedJikan& aJikan )const 
{
	tstring	strRv ;
	{
		//  
		if ( m_bPlusDisplay )
		{
			strRv += _T("- +")[ sign( aJikan.getTotalSeconds() ) + 1 ] ;
		} 
		else if ( m_bPlusToSpace )
		{
			strRv += _T("-  ")[ sign( aJikan.getTotalSeconds() ) + 1 ] ;
		}
		else
		{
			if ( aJikan.getTotalSeconds() < 0 )
			{
				strRv += _T("- +")[ sign( aJikan.getTotalSeconds() ) + 1 ] ;
			}
		}

		//	
		{
			//char	szLs[16] ;
			//sprintf( szLs , "%d" , aJikan.getHour() ) ;
			//strRv += szLs ;
			strRv += strprintf(_T("%d") , aJikan.getHour() ) ;
		}
		//	̂̃R
		{
			strRv += _T(":") ;
		}
		//	
		{
			//char	szLs[16] ;
			//sprintf( szLs , "%02d" , aJikan.getMinute() ) ;
			//strRv += szLs ;
			strRv += strprintf(_T("%02d") , aJikan.getMinute() ) ;
		}
		if ( !m_bNoSecond )
		{
			//	̂̃R
			{
				strRv += _T(":") ;
			}
			//	b
			{
				//char	szLs[16] ;
				//sprintf( szLs , "%02d" , aJikan.getSecond() ) ;
				//strRv += szLs ;
				strRv += strprintf(_T("%02d") , aJikan.getSecond()  ) ;
			}
		}
	}
	return ( strRv ) ;

};



// ****************************************************************
//	CdDedJikan
// ****************************************************************

// ********************************
//	RXgN^
// ********************************
	
CdDedJikan::CdDedJikan( int iSign , int iHour , int iMinute , int iSecond ) :
	m_iTotalSeconds( 
		sign( iSign ) * ( iHour * 60 * 60 + iMinute * 60 + iSecond ) ) 
{
}
CdDedJikan::CdDedJikan( const tstring& strTime ) 
	: m_iTotalSeconds( 0 )
{
	decode( strTime ) ;
}

// ********************************
//	CdDedJikan
// ********************************
	// ********************************
	//@name 
	// ********************************
	
CdDedJikan& CdDedJikan::setTime( int iSign , int iHour , int iMinute , int iSecond ) 
{
	m_iTotalSeconds = 
		sign( iSign ) * ( iHour * 60 * 60 + iMinute * 60 + iSecond ) ; 
	return ( *this ) ;
}
	
	
	// ********************************
	//@name 
	// ********************************
int CdDedJikan::compare( const CdDedJikan& value )const 
{
	if ( m_iTotalSeconds > value.m_iTotalSeconds ){
		return ( 1 ) ;
	}	else if ( m_iTotalSeconds < value.m_iTotalSeconds ){
		return ( -1 ) ;
	}
	return ( 0 ) ;
}
	
CdDedJikan& CdDedJikan::addSeconds( int value ) 
{
		m_iTotalSeconds += value ;

	return *this ;
}

int CdDedJikan::subJikan( const CdDedJikan& value )const
{
	int iRv = 0 ; 

		iRv = m_iTotalSeconds - value.m_iTotalSeconds ;

	return ( iRv ) ;
}

int CdDedJikan::decode( const tstring& value ) 
{
	int	iRv = 0 ;
	
	deque<tstring>	contstrValue = 
		splitc< deque<tstring> >( ':' , value ) ;
	//contstrValue = strValue  ":" ŋ؂܂B
	//	ij 
	//	strValue = "13:15:45" ̏ꍇA
	//		contstrValue[0]="13"
	//		contstrValue[1]="15"
	//		contstrValue[2]="45"
	//	strValue = "-9:15" ̏ꍇA
	//		contstrValue[0]="-9"
	//		contstrValue[1]="15"
	

	//	bȂꍇ͒ǉ
	if ( contstrValue.size() == 2 ){
		contstrValue.push_back(_T("00") ) ;
	}
	//strValue = "13:15:45","9:15:00"
	//

	if ( contstrValue.size() != 3 ){
		//	contstrValue AEEbłȂꍇ́AsłB
		m_iTotalSeconds = 0 ;
		iRv = -1 ;	//	ڐsĂ܂B
		return ( iRv ) ;
	}
	// --------------------------------
	int iSign = 0 ;
	int iHour = -1 ;
	int iMinute = -1 ;
	int iSecond = -1 ;


	//	+ ǉ܂B
	{
		tstring	strLs = contstrValue[0] ;

		if (  strLs.length() > 0 ){
			if ( strLs[0] == ' ' ){
				strLs[0] = '+' ;
			}	else if ( strLs[0] != '+' && strLs[0] != '-' ){
				strLs = tstring(_T("+")) + strLs;
			}
		}
		contstrValue[0] = strLs ;
	}



	//strValue = "13:15:45","09:15:00"

	{
		//	E
		{
			tstring	strLs = contstrValue[0] ;
			if ( strLs.length() > 0 ){
				if ( strLs[0] == '+' ){
					iSign = 1 ;
				}	else if ( strLs[0] == '-' ){
					iSign = -1 ;
				}
				strLs.erase( 0 , 1 ) ;
				if ( strLs.find_first_not_of(_T("0123456789") ) == tstring::npos ){
					iHour = _ttoi( strLs.c_str() ) ;
				}
			}
		}
		//	
		{
			tstring	strLs = contstrValue[1] ;
			if ( strLs.length() > 0 ){
				if ( strLs.find_first_not_of(_T("0123456789") ) == tstring::npos ){
					iMinute = _ttoi( strLs.c_str() ) ;
				}
			}
		}
		//	b
		{
			tstring	strLs = contstrValue[2] ;
			if ( strLs.length() > 0 ){
				if ( strLs.find_first_not_of(_T("0123456789") ) == tstring::npos ){
					iSecond = _ttoi( strLs.c_str() ) ;
				}
			}
		}
	}
	
	if ( iHour >= 0 && iMinute >= 0 && iSecond >= 0 ){
		setTime( iSign , iHour , iMinute , iSecond ) ;
	}	else	{
		m_iTotalSeconds = 0 ;
		iRv = -2 ;	//	EEb̕\LsłB
	}
	
	return ( iRv ) ;
}

} //namespace entDed
