/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CDcdTargetMfcPrintInfo.cpp
// ****************************************************************
*/

//#ifdef _DEBUG
//#define new DEBUG_NEW
//#undef THIS_FILE
//static char THIS_FILE[] = __FILE__;
//#endif

#include <sstream>
#include <string>


#include "CDcdTargetMfcPrintInfo.h"
#include "logmsg/LogMsg.h"
#include "DcDraw/CDcDeviceUnitSizeY.h"
#include "DcDraw\CConverter_WinGdi.h"

namespace DcDrawLib{
namespace DcDrawMfc{

using namespace std ;

// ****************************************************************
//	CDcdTargetMfcPrintInfo
// ****************************************************************
// ********************************
//	RXgN^
// ********************************
CDcdTargetMfcPrintInfo::CDcdTargetMfcPrintInfo( 
		CDC*			pCDC ,
		const CPrintInfo*	pCPrintInfo ) :
	m_pCDC( pCDC ) ,
	m_pCPrintInfo( pCPrintInfo )
{
	{
		RECT	aRECT = m_pCPrintInfo->m_rectDraw ;
	
		m_zonexyZone = CdDcdZoneXy( 
			CdDcdZone( aRECT.left , aRECT.right - aRECT.left ) ,
			CdDcdZone( aRECT.top , aRECT.bottom - aRECT.top ) ) ;
	}
}
	
CDcdTargetMfcPrintInfo::~CDcdTargetMfcPrintInfo() 
{
}

// ********************************
//@name	IfDcdTarget
// ********************************
HDC	CDcdTargetMfcPrintInfo::getHdc() 
{
	return m_pCDC->GetSafeHdc() ;
}
CdDcdZoneXy CDcdTargetMfcPrintInfo::getZone() 
{
	return m_zonexyZone ;
}
CdDcdZoneXy CDcdTargetMfcPrintInfo::getDrawableZone() 
{
	return m_zonexyZone ;
}

Ou<CGdiHFontHolder>	CDcdTargetMfcPrintInfo::createGdiHFontHolder(  const CdFontProp& paramCdFontProp ) 
{
	CConverter_WinGdi	aConv ;

	CdFontProp	aCdFontProp( paramCdFontProp ) ;
	if ( isPreview() && aCdFontProp.getPointTextHeight() > 0 ){
		//	`Ώۂvr[ŁA
		//	tHg|CgTCYō쐬ꍇA
		//	vr[EChEDCiWɃY[w肳Ăjł͂Ȃ
		//	DCiY[̂ȂWnjŁA_PʂɊZ悤ɂ܂
		//	iȂƁAvr[ʂł̃tHg̑傫
		//	܂j

		HDC hDcScreen = GetDC( NULL ) ;
		
		int iDp = CDcDeviceUnitSizeY( hDcScreen ).
						setPointSize( aCdFontProp.getPointTextHeight() ).
						getDeviceUnitSize() ;
		aCdFontProp.setLogicalunitTextHeight( iDp ) ;

		ReleaseDC( NULL , hDcScreen ) ;

	}
	return aConv.createGdiHFontHolder( aCdFontProp , getHdc() ) ;
}
	
Ou<CGdiHPenHolder> CDcdTargetMfcPrintInfo::createGdiHPenHolder(  const CdPenProp& aCdPenProp ) 
{
	CConverter_WinGdi	aConv ;
	return aConv.createGdiHPenHolder( aCdPenProp ) ;
}

Ou<CGdiHBrushHolder> CDcdTargetMfcPrintInfo::createGdiHBrushHolder(  const CdBrushProp& aCdBrushProp ) 
{
	CConverter_WinGdi	aConv ;
	return aConv.createGdiHBrushHolder( aCdBrushProp ) ;
}

	
// ********************************
//	CDcdTargetMfcPrintInfo
// ********************************
	// ********************************
	//@name ֘A
	// ********************************
HDC CDcdTargetMfcPrintInfo::getPrinterHdc() 
{
	return ( m_pCDC->m_hAttribDC ) ;
}
	// ********************************
	//@name 
	// ********************************
bool CDcdTargetMfcPrintInfo::isPreview() 
{
	return ( m_pCPrintInfo->m_bPreview != FALSE ) ;
}
	// ********************************
	//@name fobOp֐
	// ********************************
tstring CDcdTargetMfcPrintInfo::stringOf( CPrintInfo* pInfo ) 
{

	tstring	strRv ;
	{
		tstringstream	sstrLs ;

		sstrLs << _T("\t m_bDocObject=") << pInfo->m_bDocObject << endl ;
		// hLg DocObject ł邩ǂtOێ܂B 
		sstrLs << _T("\t m_dwFlags=") << pInfo->m_dwFlags << endl ;
		//	DocObject w肵܂B 
		sstrLs << _T("\t m_nOffsetPage=") << pInfo->m_nOffsetPage << endl ;
		//	Ă DocObject Wuł̓ DocObject ̐擪y[W̃ItZbgw肵܂B 
		//m_pPD [] _CAO {bNXŎg CPrintDialog IuWFNg̃|C^ێ܂B 
		sstrLs << _T("\t m_bDirect=") << pInfo->m_bDirect << endl ;
		//hLg ([] _CAO {bNX\) ڈ邩ǂtOێ܂B 
		sstrLs << _T("\t m_bPreview=") << pInfo->m_bPreview << endl ;
		//	hLgvr[Ă邩ǂtOێ܂B 
		sstrLs << _T("\t m_bContinuePrinting=") << pInfo->m_bContinuePrinting << endl ;
		//	t[[Np[v𑱂邩ǂtOێ܂B 
		sstrLs << _T("\t m_nCurPage=") << pInfo->m_nCurPage << endl ;
		//	݈Ăy[Wԍ܂B 
		sstrLs << _T("\t m_nNumPreviewPages=") << pInfo->m_nNumPreviewPages << endl ;
		//	vr[pEBhEɕ\Ăy[W̐܂B1A܂ 2 łB 
		sstrLs << _T("\t m_lpUserData=") << pInfo->m_lpUserData << endl ;
		//	Ǝɗpӂ\̂ւ̃|C^ێ܂B 
		sstrLs << _T("\t m_rectDraw=") <<
			 pInfo->m_rectDraw.left << _T(" ") <<  pInfo->m_rectDraw.top << _T(" ") <<
			 pInfo->m_rectDraw.right << _T(" ") <<   pInfo->m_rectDraw.bottom << endl  ;
		//	ݎgp\ȃy[ẄƂĒ`Ă钷`̈܂B 
		sstrLs << _T("\t m_strPageDesc=") << (LPCTSTR)pInfo->m_strPageDesc << endl ;
		//	y[Wԍ̕\tH[}bgw肷镶ێ܂B 

		strRv = sstrLs.str() ;
	}
	return ( strRv ) ;
};

} //namespace DcDrawMfc
} //namespace DcDrawLib
