/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
// $Id: CconvContentPosToTarget.cpp 313 2016-06-11 13:20:04Z okm $
// ****************************************************************
*/
#include <STDDEF.H>
#include "DcdCd\Pos\CconvContentPosToTarget.h"
#include "DcdCd\Pos\CconvDcdPosOnZone_PosOrgAndRate.h"
#include "DcdCd\Pos\CconvDcdPosOnZone_DcdZone.h"

namespace DcDrawLib{
namespace DcdCd{
namespace Pos{


// ****************************************************************
//	CconvContentPosToTarget
// ****************************************************************
	// --------------------------------
	//@name ֐
	// --------------------------------
DcdSize CconvContentPosToTarget::TargetPosPerContentToContentSize( 
	double dTargetPosPerContent , 
	const CdDcdZone* pTargetZone ) 
{
	DcdSize	iRv = 0 ;
	if ( pTargetZone->getSize() != 0 && 
		m_dTargetPosPerContent != (double)0 )
	{
		iRv =  (DcdSize)( (double)pTargetZone->getSize() / m_dTargetPosPerContent ) ; 
	}

	return( iRv ) ;
}

double CconvContentPosToTarget::TargetPosPerContentFromContentSize( 
	DcdSize iContentSize , 
	const CdDcdZone* pTargetZone ) 
{
	double	dRv = 0 ;
	if ( pTargetZone->getSize() != 0 && m_iContentSize != 0 )
	{
		dRv = (double)pTargetZone->getSize() / (double)m_iContentSize ;
	}
	return dRv ;
}


void CconvContentPosToTarget::
	synchronizeProp( const CdDcdZone* pTargetZone ) 
{
	// --------------------------------
	//	(1)ݒ莞̓
	// --------------------------------
	//@TargetZone w肷鑀ɂāATargetZone.Size0̏ꍇA
	//	TargetZone NULLw肳ꂽꍇ́A
	//	͍s܂B
	if ( pTargetZone != NULL && 
		pTargetZone->getSize() != 0 )
	{
		if ( m_eSynchronizeState == ESynchronizeState_TargetPosPerContent )
		{
			//	m_dTargetPosPerContent ݒ蓯҂B

			m_dTargetPosPerContent = TargetPosPerContentFromContentSize(
				m_iContentSize , pTargetZone );
			
			//	vpeB̑ݒ蓯
			m_eSynchronizeState = ESynchronizeState_None ;

			//	vpeB̃LbVpɑXV
			m_iTargetSize_Prev = pTargetZone->getSize() ;
		}
		else if ( m_eSynchronizeState == ESynchronizeState_ContentSize )
		{
			// m_iContentSize ݒ蓯҂B
			m_iContentSize = TargetPosPerContentToContentSize(
				m_dTargetPosPerContent , pTargetZone ) ;

			//	vpeB̑ݒ蓯
			m_eSynchronizeState = ESynchronizeState_None ;

			//	vpeB̃LbVpɑXV
			m_iTargetSize_Prev = pTargetZone->getSize() ;
		}
	}


	// --------------------------------
	//	(2)擾̓
	// --------------------------------

	if ( pTargetZone != NULL )
	{
		if ( m_iTargetSize_Prev == pTargetZone->getSize() )	
		{
			//	w肳ꂽ TargetZone  Size OƓȂA	
			//	̓ SynchronizeProp s܂B
			//	AwvpeB̃LbVx
			//	PropCache ƌď̂܂B
		}
		else
		{
			if ( pTargetZone->getSize() == 0 )
			{
				//@ PosAndRate [hł́w̓x̍ۂɁA
				//	TargetZone.Size=0
				//	w肳ꂽꍇ́AContentSize ͍XVA
				//	Olp܂B 
			}
			else
			{
				if ( m_eMode == EModePosAndRate )
				{
					//	̃NX PosAndRate [hł́A
					//	[U[TargetZone
					//	w肷鑀sтɁA ContentSize 
					//	XV܂BContentSize ́A
					//	TargetZone Size ω閈ɁAlω܂B
					m_iContentSize = TargetPosPerContentToContentSize(
						m_dTargetPosPerContent , pTargetZone ) ;
				}
				else
				{
					//	Zone [hłlɁATargetPosPerContent wA
					//	擾邱
					//	ł܂B̃NX̃[U[TargetZone
					//	w肷鑀sсA
					//	TargetPosPerContentXV܂B
					m_dTargetPosPerContent = TargetPosPerContentFromContentSize(
						m_iContentSize , pTargetZone );
				}
			}
			//	vpeB̃LbVpɑXV
			m_iTargetSize_Prev = pTargetZone->getSize() ;
		}
	}
}

	// ********************************
	//	RXgN^
	// ********************************
CconvContentPosToTarget::CconvContentPosToTarget() :
	m_eMode( EModePosAndRate ) , 
	m_iContentPos( 0 ) ,
	m_dTargetPosPerContent( 1 ) ,
	m_iContentSize( 1 ),
	m_eSynchronizeState( ESynchronizeState_None ) ,
	m_iTargetSize_Prev( 0 ) {}
	
CconvContentPosToTarget::CconvContentPosToTarget( 
	EMode	eMode ) :
	m_eMode( eMode ) , 
	m_iContentPos( 0 ) ,
	m_dTargetPosPerContent( 1 ) ,
	m_iContentSize( 1 ) ,
	m_eSynchronizeState( ESynchronizeState_None ) ,
	m_iTargetSize_Prev( 0 ) {}

CconvContentPosToTarget::CconvContentPosToTarget( 
		DcdPos	iContentPos ,
		double dTargetPosPerContent ) :
	m_eMode( EModePosAndRate ) , 
	m_iContentPos( iContentPos ) ,
	m_dTargetPosPerContent( dTargetPosPerContent ) ,
	m_iContentSize( 1 ) , 
	m_eSynchronizeState( ESynchronizeState_ContentSize ) ,
	m_iTargetSize_Prev( 0 ) {}

CconvContentPosToTarget::CconvContentPosToTarget( 
		const CdDcdZone& zoneContent ) :
	m_eMode( EModeZone ) , 
	m_iContentPos( zoneContent.getPos() ) ,
	m_dTargetPosPerContent( 1 ) ,
	m_iContentSize( zoneContent.getSize() ) ,
	m_eSynchronizeState( ESynchronizeState_TargetPosPerContent ) ,
	m_iTargetSize_Prev( 0 ) {}


	// ********************************
	//@name CconvContentPosToTarget-
	// ********************************
CconvContentPosToTarget::EMode	CconvContentPosToTarget::getMode()const 
{
	return m_eMode ;
}
void CconvContentPosToTarget::setMode( EMode	value ) 
{
	m_eMode = value ;
}

DcdPos	CconvContentPosToTarget::getContentPos()const 
{
	return m_iContentPos ;
}
void CconvContentPosToTarget::setContentPos( DcdPos value ) 
{
	m_iContentPos = value ;
}

double CconvContentPosToTarget::getTargetPosPerContent()const 
{
	return m_dTargetPosPerContent ;
}
DcdSize	CconvContentPosToTarget::getContentSize()const 
{
	return m_iContentSize ;
}


	// ********************************
	//@name CconvContentPosToTarget-TargetPosPerContent,ContentSize ̎擾Eݒ
	// ********************************

double CconvContentPosToTarget::getTargetPosPerContent( 
	const CdDcdZone* pTargetZone ) 
{
	//	vpeB̓
	synchronizeProp( pTargetZone ) ;

	return m_dTargetPosPerContent ;
}

void CconvContentPosToTarget::setTargetPosPerContent( 
	double value , const CdDcdZone* pTargetZone ) 
{
	m_dTargetPosPerContent = value ;

	/// m_iContentSize ݒ蓯҂B
	m_eSynchronizeState = ESynchronizeState_ContentSize ;

	//	vpeB̓
	synchronizeProp( pTargetZone ) ;
}

DcdSize CconvContentPosToTarget::getContentSize( 
	const CdDcdZone* pTargetZone ) 
{
	//	vpeB̓
	synchronizeProp( pTargetZone ) ;

	return m_iContentSize ;
}

void CconvContentPosToTarget::setContentSize( 
	DcdSize value , const CdDcdZone* pTargetZone ) 
{
	m_iContentSize = value ;

	// m_dTargetPosPerContent ݒ蓯҂B
	m_eSynchronizeState = ESynchronizeState_TargetPosPerContent ;

	//	vpeB̓
	synchronizeProp( pTargetZone ) ;
}

void CconvContentPosToTarget::setContentPosAndRate( 
		DcdPos posContentPos , 
		double dTargetPosPerContent ,
		const CdDcdZone* pTargetZone ) 
{
	setContentPos( posContentPos ) ;
	setTargetPosPerContent( dTargetPosPerContent , pTargetZone ) ;

	//	vpeB̓
	synchronizeProp( pTargetZone ) ;
}


CdDcdZone CconvContentPosToTarget::getContentZone( 
	const CdDcdZone* pTargetZone ) 
{
	//	vpeB̓
	synchronizeProp( pTargetZone ) ;

	return CdDcdZone( getContentPos() , getContentSize( pTargetZone ) ) ;
}
void CconvContentPosToTarget::setContentZone( 
	const CdDcdZone& zoneContent , 
	const CdDcdZone* pTargetZone ) 
{
	setContentPos( zoneContent.getPos() ) ;
	setContentSize( zoneContent.getSize() , pTargetZone ) ;

	//	vpeB̓
	synchronizeProp( pTargetZone ) ;
}
	// ********************************
	//@name CconvContentPosToTarget-Wϊ
	// ********************************


DcdPos	CconvContentPosToTarget::ContentPosToTarget( 
		DcdPos posContent , const CdDcdZone& aTargetZone ) 
{
	DcdPos posRv =  0 ;

	//	vpeB̓
	synchronizeProp( &aTargetZone ) ;

	if ( m_eMode == EModePosAndRate )
	{
		CconvDcdPosOnZone_PosOrgAndRate	aConv( 
			m_iContentPos , aTargetZone.getPos() , m_dTargetPosPerContent ) ;
		posRv  =aConv.Zone1PosToZone2( posContent ) ;
	}
	else if ( m_eMode == EModeZone )
	{
		CconvDcdPosOnZone_DcdZone	aConv( 
			CdDcdZone( m_iContentPos , m_iContentSize ),
			aTargetZone ) ;
		posRv  = aConv.Zone1PosToZone2( posContent ) ;
	}
	return posRv;
}

CdDcdZone CconvContentPosToTarget::ContentZoneToTarget( 
		const CdDcdZone& zoneContent , const CdDcdZone& aTargetZone ) 
{
	CdDcdZone	zoneRv  ; 

	//	vpeB̓
	synchronizeProp( &aTargetZone ) ;

	if ( m_eMode == EModePosAndRate )
	{
		CconvDcdPosOnZone_PosOrgAndRate	aConv( 
			m_iContentPos , aTargetZone.getPos() , m_dTargetPosPerContent ) ;
		zoneRv = aConv.Zone1ToZone2( zoneContent ) ;
	}
	else if ( m_eMode == EModeZone )
	{
		CconvDcdPosOnZone_DcdZone	aConv( 
			CdDcdZone( m_iContentPos , m_iContentSize ),
			aTargetZone ) ;
		zoneRv = aConv.Zone1ToZone2( zoneContent ) ;
	}
	return zoneRv ;
}

DcdPos CconvContentPosToTarget::ContentPosFromTarget( 
		DcdPos posTarget , const CdDcdZone& aTargetZone ) 
{
	DcdPos posRv =  0 ;

	//	vpeB̓
	synchronizeProp( &aTargetZone ) ;

	if ( m_eMode == EModePosAndRate )
	{
		CconvDcdPosOnZone_PosOrgAndRate	aConv( 
			m_iContentPos , aTargetZone.getPos() , m_dTargetPosPerContent ) ;
		posRv  = aConv.Zone1PosFromZone2( posTarget ) ;
	}
	else if ( m_eMode == EModeZone )
	{
		CconvDcdPosOnZone_DcdZone	aConv( 
			CdDcdZone( m_iContentPos , m_iContentSize ),
			aTargetZone ) ;
		posRv  = aConv.Zone1PosFromZone2( posTarget ) ;
	}
	return posRv;
}

CdDcdZone CconvContentPosToTarget::ContentZoneFromTarget( 
		const CdDcdZone& zoneTarget , const CdDcdZone& aTargetZone ) 
{
	CdDcdZone	zoneRv  ; 

	//	vpeB̓
	synchronizeProp( &aTargetZone ) ;


	if ( m_eMode == EModePosAndRate )
	{
		CconvDcdPosOnZone_PosOrgAndRate	aConv( 
			m_iContentPos , aTargetZone.getPos() , m_dTargetPosPerContent ) ;
		zoneRv =  aConv.Zone1FromZone2( zoneTarget ) ;
	}
	else if ( m_eMode == EModeZone )
	{
		CconvDcdPosOnZone_DcdZone	aConv( 
			CdDcdZone( m_iContentPos , m_iContentSize ),
			aTargetZone ) ;
		zoneRv =  aConv.Zone1FromZone2( zoneTarget ) ;
	}
	return zoneRv ;
}

} //namespace Pos
} //namespace DcdCd
} //namespace DcDrawLib
